diff -rNci gcc-2.7.2/sched.c gcc-2.7.2p/sched.c
*** gcc-2.7.2/sched.c	Thu Jun 15 12:06:39 1995
--- gcc-2.7.2p/sched.c	Tue Jan 30 21:06:34 1996
***************
*** 125,131 ****
--- 125,153 ----
  #include "insn-config.h"
  #include "insn-attr.h"
  
+ /* intel1 */
+ #ifndef STACK_PUSH_CODE
+ #ifdef STACK_GROWS_DOWNWARD
+ #define STACK_PUSH_CODE PRE_DEC
+ #else
+ #define STACK_PUSH_CODE PRE_INC
+ #endif
+ #endif
  #ifdef INSN_SCHEDULING
+ /* intel1 */
+ #ifndef STACK_PUSH_CODE
+ #ifdef STACK_GROWS_DOWNWARD
+ #define STACK_PUSH_CODE PRE_DEC
+ #else
+ #define STACK_PUSH_CODE PRE_INC
+ #endif
+ #endif
+ #ifdef SMALL_REGISTER_CLASSES
+   /* can't move anything past a hard register */
+ static rtx first_insn_to_pivot;
+ static rtx last_hard_reg_insn;
+ #endif
+ 
  /* Arrays set up by scheduling for the same respective purposes as
     similar-named arrays set up by flow analysis.  We work with these
     arrays during the scheduling pass so we can compare values against
***************
*** 146,151 ****
--- 168,184 ----
  static regset reg_pending_sets;
  static int reg_pending_sets_all;
  
+ /* intel1 */
+ #ifdef NO_STACK_REG_REORDER
+ /* don't reorder insns that refernce stack registers */
+ static rtx prev_stack_reg_insn = NULL;
+ #endif
+ /* intel1 */
+ #ifdef STACK_REGS
+ static int maintain_order = 0;
+ #endif
+ static FILE * cur_dump_file;
+ 
  /* Vector indexed by INSN_UID giving the original ordering of the insns.  */
  static int *insn_luid;
  #define INSN_LUID(INSN) (insn_luid[INSN_UID (INSN)])
***************
*** 293,305 ****
  };
  
  /* Forward declarations.  */
  static rtx canon_rtx			PROTO((rtx));
  static int rtx_equal_for_memref_p	PROTO((rtx, rtx));
  static rtx find_symbolic_term		PROTO((rtx));
  static int memrefs_conflict_p		PROTO((int, rtx, int, rtx,
  					       HOST_WIDE_INT));
  static void add_dependence		PROTO((rtx, rtx, enum reg_note));
! static void remove_dependence		PROTO((rtx, rtx));
  static rtx find_insn_list		PROTO((rtx, rtx));
  static int insn_unit			PROTO((rtx));
  static unsigned int blockage_range	PROTO((int, rtx));
--- 326,342 ----
  };
  
  /* Forward declarations.  */
+ 
+ /* intel1 */
+ static int is_part_of_group			PROTO((rtx, rtx));
+ static int prev_insts_in_block		PROTO((int, rtx));
  static rtx canon_rtx			PROTO((rtx));
  static int rtx_equal_for_memref_p	PROTO((rtx, rtx));
  static rtx find_symbolic_term		PROTO((rtx));
  static int memrefs_conflict_p		PROTO((int, rtx, int, rtx,
  					       HOST_WIDE_INT));
  static void add_dependence		PROTO((rtx, rtx, enum reg_note));
! void remove_dependence		PROTO((rtx, rtx));
  static rtx find_insn_list		PROTO((rtx, rtx));
  static int insn_unit			PROTO((rtx));
  static unsigned int blockage_range	PROTO((int, rtx));
***************
*** 629,634 ****
--- 666,906 ----
    else
      y = canon_rtx (y);
  
+   /* intel1
+      Missing special handling of a push onto the stack.  */
+   if (reload_completed
+       &&
+       (GET_CODE (x) == STACK_PUSH_CODE
+        && XEXP (x, 0) == stack_pointer_rtx)
+       ||
+       (GET_CODE (y) == STACK_PUSH_CODE
+        && XEXP (y, 0) == stack_pointer_rtx)
+       )
+     {
+       rtx *push, *non_push;
+ 
+       if (GET_CODE (x) == STACK_PUSH_CODE
+           && XEXP (x, 0) == stack_pointer_rtx)
+         {
+           push = &x;
+           non_push = &y;
+         }
+       else
+         {
+           push = &y;
+           non_push = &x;
+         }
+       if (find_symbolic_term (*non_push) != NULL)
+         {  /* push onto stack does not conflict with global */
+           return (0);
+         }
+       if (RTX_IS_SPILL_P (*non_push))
+         { /* push onto stack does not overlap with spill slot */
+           return (0);
+         }
+       /* Check to see if the non push is a stack slot */
+       if (c == 0 && GET_CODE (*non_push) == PLUS 
+           && XEXP ( *non_push, 0) == stack_pointer_rtx 
+           && !frame_pointer_needed)
+         {
+           if ( GET_CODE (XEXP ( *non_push, 1)) == CONST_INT
+                && XINT (XEXP (*non_push, 1), 0) 
+                   > GET_MODE_SIZE (GET_MODE (*push)))
+             {
+               return (0);
+             }
+         }
+       else if (c == 0 && GET_CODE (*non_push) == PLUS 
+           && XEXP ( *non_push, 0) == frame_pointer_rtx
+           && frame_pointer_needed)
+         {
+           if ( GET_CODE (XEXP ( *non_push, 1)) == CONST_INT)
+             {
+               return (0); /* Definitely not the same as the push if
+                              frame_pointer is used.  */
+             }
+         }
+     }
+   
+   
+   /* intel1
+      Missing handling of a spill slot - can't conflict with anything
+      that is not a spill slot */
+   if (reload_completed && RTX_IS_SPILL_P (x) != RTX_IS_SPILL_P (y)
+       && !rtx_equal_p(x,y) /*just to be safe */)
+     { /* Actually some spill slots are not being marked at present -
+          but no non spill slots are ever marked.  So make sure
+          that the non spill slot does not overlap with spill slot */
+       rtx *spill, *non_spill;
+       int *spill_size, *non_spill_size, spill_offset, non_spill_offset, 
+           spill_unknown, non_spill_unknown, maybe_spill;
+       spill_unknown = 0;
+       non_spill_unknown = 0;
+       maybe_spill = 0;
+       if (RTX_IS_SPILL_P (x))
+         {
+           spill = &x;
+           spill_size = &xsize;
+           non_spill = &y;
+           non_spill_size = &ysize;
+         }
+       else
+         {
+           spill = &y;
+           spill_size = &ysize;
+           non_spill = &x;
+           non_spill_size = &xsize;
+         }
+       if (GET_CODE (*non_spill) == PLUS)
+         {
+           if (GET_CODE (XEXP (*non_spill, 1)) == CONST_INT)
+             {
+               non_spill_offset = XINT (XEXP (*non_spill, 1), 0);
+             }
+           else
+             {
+               non_spill_unknown = 1;
+             }
+           if (GET_CODE (XEXP (*non_spill, 0)) == REG
+               && ((frame_pointer_needed && XEXP (*non_spill, 0) == frame_pointer_rtx)
+                   || XEXP (*non_spill, 0) == stack_pointer_rtx))
+             {
+               maybe_spill = 1; /* It may overlap the spill slot */
+             }
+         }
+       else
+       if (GET_CODE (*non_spill) == REG
+           && ((frame_pointer_needed && *non_spill == frame_pointer_rtx)
+               || *non_spill == stack_pointer_rtx))
+         {
+           non_spill_offset = 0;
+           maybe_spill = 1;
+         }
+       if (maybe_spill == 0)
+         return (0);
+         
+       if (GET_CODE (*spill) == PLUS)
+         {
+           if (GET_CODE (XEXP (*spill, 1)) == CONST_INT)
+             {
+               spill_offset = XINT (XEXP (*spill, 1), 0);
+             }
+           else
+             {
+               spill_unknown = 1;
+             }
+           if (GET_CODE (XEXP (*spill, 0)) == REG
+               && ((frame_pointer_needed && XEXP (*spill, 0) == frame_pointer_rtx)
+                   || XEXP (*spill, 0) == stack_pointer_rtx))
+             {
+               ; /* ok */
+             }
+           else
+             {
+               spill_unknown = 1;
+             }
+         }
+       else
+       if (GET_CODE (*spill) == REG
+           && ((frame_pointer_needed && *spill == frame_pointer_rtx)
+               || *spill == stack_pointer_rtx))
+         {
+          spill_offset = 0;
+         }
+       else
+         {
+           spill_unknown = 1;
+         }
+       if (non_spill_unknown == 0  && spill_unknown == 0)
+         {
+           if (non_spill_offset < spill_offset)
+             return (!(non_spill_offset + *non_spill_size <= spill_offset));
+           else
+             return (!(spill_offset + *spill_size <= non_spill_offset));
+         } 
+     }
+   
+   /* intel1
+      Missing handling two spill slots conflict only if they overlap */
+   if (reload_completed && RTX_IS_SPILL_P (y) && RTX_IS_SPILL_P (x) 
+       && c == 0 
+       && !rtx_equal_p(y, x))
+     {
+       int x_offset, y_offset, x_unknown, y_unknown;
+       x_unknown = y_unknown = 0;
+       if (GET_CODE (x) == PLUS)
+         {
+           if (GET_CODE (XEXP (x, 1)) == CONST_INT)
+             {
+               x_offset = XINT (XEXP (x, 1), 0);
+             }
+           else
+             {
+               x_unknown = 1;
+             }
+           if (GET_CODE (XEXP (x, 0)) == REG
+               && ((frame_pointer_needed && XEXP (x, 0) == frame_pointer_rtx)
+                   || XEXP (x, 0) == stack_pointer_rtx))
+             {
+               ; /* ok */
+             }
+           else
+             {
+               x_unknown = 1;
+             }
+         }
+       else
+       if (GET_CODE (x) == REG
+           && ((frame_pointer_needed && x == frame_pointer_rtx)
+               || x == stack_pointer_rtx))
+         {
+          x_offset = 0;
+         }
+       else
+         {
+           x_unknown = 1;
+         }
+       if (GET_CODE (y) == PLUS)
+         {
+           if (GET_CODE (XEXP (y, 1)) == CONST_INT)
+             {
+               y_offset = XINT (XEXP (y, 1), 0);
+             }
+           else
+             {
+               y_unknown = 1;
+             }
+           if (GET_CODE (XEXP (y, 0)) == REG
+               && ((frame_pointer_needed && XEXP (y, 0) == frame_pointer_rtx)
+                   || XEXP (y, 0) == stack_pointer_rtx))
+             {
+               ; /* ok */
+             }
+           else
+             {
+               y_unknown = 1;
+             }
+         }
+       else
+       if (GET_CODE (y) == REG
+           && ((frame_pointer_needed && y == frame_pointer_rtx)
+               || y == stack_pointer_rtx))
+         {
+          y_offset = 0;
+         }
+       else
+         {
+           y_unknown = 1;
+         }
+       if (x_unknown == 0  && y_unknown == 0)
+         {
+           if (x_offset < y_offset)
+             return (!(x_offset + xsize <= y_offset));
+           else
+             return (!(y_offset + ysize <= x_offset));
+         } 
+     }
+   
    if (rtx_equal_for_memref_p (x, y))
      return (xsize == 0 || ysize == 0 ||
  	    (c >= 0 && xsize > c) || (c < 0 && ysize+c > 0));
***************
*** 922,928 ****
--- 1194,1208 ----
  	 SCHED_GROUP_P.  */
        while (NEXT_INSN (next) && SCHED_GROUP_P (NEXT_INSN (next))
  	     && GET_CODE (NEXT_INSN (next)) != CODE_LABEL)
+       {
+         /* intel1 - next might already be part of this SCHED_GROUP,
+         */
+         if(next==insn )
+         {
+ 	  return;
+         }
  	next = NEXT_INSN (next);
+       }
  
        /* Again, don't depend an insn on itself.  */
        if (insn == next)
***************
*** 956,962 ****
  /* Remove ELEM wrapped in an INSN_LIST from the LOG_LINKS
     of INSN.  Abort if not found.  */
  
! static void
  remove_dependence (insn, elem)
       rtx insn;
       rtx elem;
--- 1236,1242 ----
  /* Remove ELEM wrapped in an INSN_LIST from the LOG_LINKS
     of INSN.  Abort if not found.  */
  
! void
  remove_dependence (insn, elem)
       rtx insn;
       rtx elem;
***************
*** 1217,1225 ****
--- 1497,1518 ----
        if (function_units[unit].blockage_range_function)
  	{
  	  if (function_units[unit].blockage_function)
+ 	    {
+ 	    /* intel1 */
+ #ifdef ADJUST_BLOCKAGE
+             {
+               int blockage = (function_units[unit].blockage_function
+ 		       (insn, unit_last_insn[instance]));
+ 	      ADJUST_BLOCKAGE (unit_last_insn[instance], insn, blockage);
+ 	      tick +=  blockage 
+ 		       - function_units[unit].max_blockage;
+ 	    }
+ #else
  	    tick += (function_units[unit].blockage_function
  		     (insn, unit_last_insn[instance])
  		     - function_units[unit].max_blockage);
+ #endif
+ 	    }
  	  else
  	    tick += ((int) MAX_BLOCKAGE_COST (blockage_range (unit, insn))
  		     - function_units[unit].max_blockage);
***************
*** 1706,1711 ****
--- 1999,2031 ----
  		/* Function calls clobber all call_used regs.  */
  		add_dependence (insn, last_function_call, REG_DEP_ANTI);
  	    }
+ #ifdef SMALL_REGISTER_CLASSES
+ /* intel1 
+    lifetime of hard registers must not be changed so this
+    insn becomes a pivot in the block.
+ */
+           if(reload_completed==0 && regno!=STACK_POINTER_REGNUM
+              && regno!=FRAME_POINTER_REGNUM)
+             {
+               rtx tinsn;
+ 
+               tinsn = first_insn_to_pivot;
+               while(tinsn!=insn)
+                 {
+                   if(GET_CODE(tinsn)==INSN || GET_CODE(tinsn)==CALL_INSN)
+                   {
+                     add_dependence (insn,tinsn,0);
+                   }
+                   tinsn = NEXT_INSN(tinsn);
+                 }
+               if(last_hard_reg_insn)
+                 {
+                   add_dependence (insn,last_hard_reg_insn,0);
+                 }
+               first_insn_to_pivot = insn; 
+               last_hard_reg_insn = insn;
+             }
+ #endif
  	}
        else
  	{
***************
*** 1806,1811 ****
--- 2126,2151 ----
    if (x == 0)
      return;
  
+ /* intel1 */
+ #ifdef STACK_REGS
+ #ifdef IS_STACK_MODE
+ #ifdef NO_STACK_REG_REORDER
+   if (NO_STACK_REG_REORDER)
+     {
+       if (prev_stack_reg_insn!=NULL && insn!=prev_stack_reg_insn
+          && IS_STACK_MODE (GET_MODE (x)))
+         {
+ 	    add_dependence (insn, prev_stack_reg_insn, REG_DEP_TMP);
+         }
+       if (IS_STACK_MODE (GET_MODE (x)))
+         {
+           prev_stack_reg_insn = insn;
+         }
+     }
+ #endif
+ #endif
+ #endif
+ 
    code = GET_CODE (x);
  
    switch (code)
***************
*** 1871,1876 ****
--- 2211,2243 ----
  		  /* Function calls clobber all call_used regs.  */
  		  add_dependence (insn, last_function_call, REG_DEP_ANTI);
  	      }
+ #ifdef SMALL_REGISTER_CLASSES
+ /* intel1 
+    lifetime of hard registers must not be changed so this
+    insn becomes a pivot in the block.
+ */
+             if(reload_completed==0 && regno!=STACK_POINTER_REGNUM
+              && regno!=FRAME_POINTER_REGNUM)
+               {
+                 rtx tinsn;
+   
+                 tinsn = first_insn_to_pivot;
+                 while(tinsn!=insn)
+                   {
+                     if(GET_CODE(tinsn)==INSN || GET_CODE(tinsn)==CALL_INSN)
+                     {
+                       add_dependence (insn,tinsn,0);
+                     }
+                     tinsn = NEXT_INSN(tinsn);
+                   }
+                 if(last_hard_reg_insn)
+                   {
+                     add_dependence (insn,last_hard_reg_insn,0);
+                   }
+                 first_insn_to_pivot = insn; 
+                 last_hard_reg_insn = insn;
+               }
+ #endif
  	  }
  	else
  	  {
***************
*** 2023,2028 ****
--- 2390,2403 ----
    int maxreg = max_reg_num ();
    int i;
  
+ #ifdef SMALL_REGISTER_CLASSES
+ /* intel1 */
+   if (reload_completed==0 && last_hard_reg_insn!=NULL)
+     {
+       add_dependence (insn,last_hard_reg_insn,0);
+     }
+ #endif
+ 
    if (code == SET || code == CLOBBER)
      sched_analyze_1 (x, insn);
    else if (code == PARALLEL)
***************
*** 2170,2175 ****
--- 2545,2571 ----
    register int luid = 0;
    rtx loop_notes = 0;
  
+ /* intel1 */
+   rtx pinsn;
+ #ifdef STACK_REGS
+   pinsn = NULL;
+   if (maintain_order && reload_completed==0)
+     { /* A block we don't want to change order but keep track of
+          register life information.  */
+       for (insn = head; insn != tail; insn = NEXT_INSN (insn))
+         {
+           if (GET_CODE (insn) == INSN || GET_CODE (insn) == CALL_INSN)
+             {
+               if (pinsn)
+                 {
+                   add_dependence (insn, pinsn, REG_DEP_TMP);
+                 }
+               pinsn = insn;
+             }
+         }
+     }
+ #endif
+ 
    for (insn = head; ; insn = NEXT_INSN (insn))
      {
        INSN_LUID (insn) = luid++;
***************
*** 2514,2519 ****
--- 2910,2931 ----
        rtx note;
        int n_deaths = 0;
  
+       /* intel1 */
+ #ifdef STACK_REGS
+ #ifdef IS_STACK_MODE
+ #ifdef STACK_REG_REORDER
+       /* For stack registers don't take lifetimes into account */
+       if (birthing_insn_p (PATTERN (prev)) && STACK_REG_REORDER && 0)
+ 	{
+ 	  if (GET_CODE (prev) == INSN && GET_CODE (PATTERN (prev)) == SET
+ 	      && IS_STACK_MODE (GET_MODE (SET_DEST (PATTERN (prev)))))
+ 	    {
+ 	      return;
+ 	    }
+ 	}
+ #endif
+ #endif
+ #endif
        /* ??? This code has no effect, because REG_DEAD notes are removed
  	 before we ever get here.  */
        for (note = REG_NOTES (prev); note; note = XEXP (note, 1))
***************
*** 2724,2730 ****
  
    if (dead_notes == 0)
      {
! #if 1
        abort ();
  #else
        link = rtx_alloc (EXPR_LIST);
--- 3136,3143 ----
  
    if (dead_notes == 0)
      {
! /* Sorry for this hack */
! #if 0
        abort ();
  #else
        link = rtx_alloc (EXPR_LIST);
***************
*** 3169,3178 ****
--- 3582,3625 ----
    register struct sometimes *regs_sometimes_live;
    int sometimes_max;
  
+   /* intel1 */
+ #ifdef HAVE_cc0
+   rtx prev_to_cc0_setter;
+ #endif
+ #ifdef AGI
+   int possible_agi = 0;
+ #endif
+ #ifdef NO_STACK_REG_REORDER
+   rtx tinsn, tlink, tprev_link;
+ #endif /* NO_STACK_REG_REORDER */
+ 
    if (file)
      fprintf (file, ";;\t -- basic block number %d from %d to %d --\n",
  	     b, INSN_UID (basic_block_head[b]), INSN_UID (basic_block_end[b]));
  
+ /* intel1 */
+ #ifdef NO_STACK_REG_REORDER
+   prev_stack_reg_insn = NULL;
+ #endif
+ #ifdef STACK_REGS
+   maintain_order = 0;
+   if (STACK_NON_STACK_INTERLEAVE || STACK_REG_REORDER)
+     {
+       rtx tinsn = head;
+       int found_stack_mode = 0;
+       while (tinsn && !found_stack_mode && tinsn != tail)
+         {
+           if (GET_CODE (tinsn) == INSN && GET_CODE (PATTERN (tinsn)) == SET
+               && IS_STACK_MODE (GET_MODE (SET_DEST (PATTERN (tinsn)))))
+             {
+               found_stack_mode = 1;
+             }
+           tinsn = next_nonnote_insn (tinsn);
+         }
+       maintain_order = !found_stack_mode;
+     }
+ #endif
+ 
    i = max_reg_num ();
    reg_last_uses = (rtx *) alloca (i * sizeof (rtx));
    bzero ((char *) reg_last_uses, i * sizeof (rtx));
***************
*** 3264,3269 ****
--- 3711,3721 ----
  
    LOG_LINKS (sched_before_next_call) = 0;
  
+ #ifdef SMALL_REGISTER_CLASSES
+ /* intel1 */
+   first_insn_to_pivot = head;
+   last_hard_reg_insn = NULL;
+ #endif
    n_insns += sched_analyze (head, tail);
    if (n_insns == 0)
      {
***************
*** 3280,3285 ****
--- 3732,3823 ----
    /* TAIL is now the last of the insns to be rearranged.
       Put those insns into the READY vector.  */
    insn = tail;
+ /* intel1 */
+ #ifdef HAVE_cc0
+   /* intel1 further if we have done compare elimination then the
+      insn before the compare should not be moved */
+   if (head!=tail 
+      && GET_CODE (basic_block_end[b])==JUMP_INSN 
+      && GET_CODE (PATTERN (basic_block_end[b]))!=PARALLEL 
+      && GET_CODE (PATTERN (basic_block_end[b]))!=ADDR_VEC 
+      && GET_CODE (XEXP (SET_SRC (PATTERN (basic_block_end[b])),0))==NE 
+      && GET_CODE (PREV_INSN (basic_block_end[b]))==INSN 
+      && GET_CODE (PATTERN (PREV_INSN (basic_block_end[b])))==SET 
+      && SET_DEST (PATTERN (PREV_INSN (basic_block_end[b])))==cc0_rtx 
+      && GET_CODE (SET_SRC (PATTERN (PREV_INSN (basic_block_end[b]))))==COMPARE 
+      && XEXP (SET_SRC (PATTERN (PREV_INSN (basic_block_end[b]))),1)==const0_rtx)
+     {
+       prev_to_cc0_setter = 
+         prev_nonnote_insn( PREV_INSN (basic_block_end[b]));
+       if (! (prev_to_cc0_setter && RTX_IS_RISC_P (prev_to_cc0_setter))
+          && prev_insts_in_block (b,PREV_INSN (basic_block_end[b])) 
+          && (head != PREV_INSN (basic_block_end[b])) )
+         {
+           SCHED_GROUP_P (PREV_INSN (basic_block_end[b]))=1;
+           /* Also must remove the 
+              prev_nonnote_insn(PREV_INSN(basic_block_end[b]) from the
+              dependency chain of both basic_block_end[b] and
+              PREV_INSN(basic_block_end[b]), to ensure that it doesn't
+              go through the ready list also */
+           if(prev_to_cc0_setter 
+              && (GET_CODE (prev_to_cc0_setter)==INSN 
+                  || GET_CODE (prev_to_cc0_setter)==CALL_INSN )
+ 	     && ! RTX_IS_RISC_P (prev_to_cc0_setter))  /* intel2 */
+             {
+ 	      if (find_insn_list (prev_to_cc0_setter, 
+ 	                          LOG_LINKS (PREV_INSN (basic_block_end[b]))))
+ 	        remove_dependence (PREV_INSN (basic_block_end[b]), 
+ 	                           prev_to_cc0_setter);
+ 	      if (find_insn_list (prev_to_cc0_setter, 
+ 	                          LOG_LINKS ( basic_block_end[b])))
+ 	        remove_dependence (basic_block_end[b], 
+ 	                           prev_to_cc0_setter);
+ 	    }
+         }
+       else
+         SCHED_GROUP_P(PREV_INSN(basic_block_end[b]))=0;
+     } 
+   else
+   if (head!=tail 
+      && GET_CODE (basic_block_end[b])==JUMP_INSN 
+      && GET_CODE (PATTERN (basic_block_end[b]))!=PARALLEL 
+      && GET_CODE (PATTERN (basic_block_end[b]))!=ADDR_VEC 
+      && GET_CODE (PREV_INSN (basic_block_end[b]))==INSN 
+      && GET_CODE (PATTERN (PREV_INSN (basic_block_end[b])))==SET 
+      && SET_DEST (PATTERN (PREV_INSN (basic_block_end[b])))==cc0_rtx 
+      && GET_CODE (SET_SRC (PATTERN (PREV_INSN (basic_block_end[b]))))!=COMPARE)
+     {
+       prev_to_cc0_setter = 
+         prev_nonnote_insn( PREV_INSN (basic_block_end[b]));
+       if (! (prev_to_cc0_setter && RTX_IS_RISC_P (prev_to_cc0_setter))
+          && prev_insts_in_block (b,PREV_INSN (basic_block_end[b])) 
+          && (head != PREV_INSN (basic_block_end[b])) )
+         {
+           SCHED_GROUP_P (PREV_INSN (basic_block_end[b]))=1;
+           /* Also must remove the 
+              prev_nonnote_insn(PREV_INSN(basic_block_end[b]) from the
+              dependency chain of both basic_block_end[b] and
+              PREV_INSN(basic_block_end[b]), to ensure that it doesn't
+              go through the ready list also */
+           if(prev_to_cc0_setter 
+              && (GET_CODE (prev_to_cc0_setter) == INSN 
+                  || GET_CODE (prev_to_cc0_setter) == CALL_INSN )
+ 	     && ! RTX_IS_RISC_P (prev_to_cc0_setter))  /* intel2 */
+             {
+ 	      if (find_insn_list (prev_to_cc0_setter, 
+ 	                          LOG_LINKS (PREV_INSN (basic_block_end[b]))))
+ 	        remove_dependence (PREV_INSN (basic_block_end[b]), 
+ 	                           prev_to_cc0_setter);
+ 	      if (find_insn_list (prev_to_cc0_setter, 
+ 	                          LOG_LINKS ( basic_block_end[b])))
+ 	        remove_dependence (basic_block_end[b], 
+ 	                           prev_to_cc0_setter);
+ 	    }
+         }
+       else
+         SCHED_GROUP_P(PREV_INSN(basic_block_end[b]))=0;
+     } 
+ #endif
  
    /* For all branches, calls, uses, and cc0 setters, force them to remain
       in order at the end of the block by adding dependencies and giving
***************
*** 3697,3710 ****
  		for (; insn; insn = NEXT_INSN (insn))
  		  {
  		    if (file)
! 		      fprintf (file, ";; launching %d before %d with %d stalls at T-%d\n",
! 			       INSN_UID (insn), INSN_UID (last), stalls, clock);
  		    ready[new_ready++] = insn;
  		    q_size -= 1;
  		  }
  		insn_queue[NEXT_Q_AFTER (q_ptr, stalls)] = 0;
  		break;
  	      }
  
  	  q_ptr = NEXT_Q_AFTER (q_ptr, stalls); clock += stalls;
  	}
--- 4235,4253 ----
  		for (; insn; insn = NEXT_INSN (insn))
  		  {
  		    if (file)
! 		      fprintf (file, ";; launching %d before %d with %d stalls at T-%d i_q[%d]\n",
! 			       INSN_UID (insn), INSN_UID (last), stalls, clock, new_ready);
  		    ready[new_ready++] = insn;
  		    q_size -= 1;
  		  }
  		insn_queue[NEXT_Q_AFTER (q_ptr, stalls)] = 0;
  		break;
  	      }
+          /* intel1 */
+ #ifdef AGI
+           if (new_ready == 1)
+             possible_agi = 1;
+ #endif
  
  	  q_ptr = NEXT_Q_AFTER (q_ptr, stalls); clock += stalls;
  	}
***************
*** 3715,3721 ****
  
        if (file)
  	{
! 	  fprintf (file, ";; ready list at T-%d:", clock);
  	  for (i = 0; i < new_ready; i++)
  	    fprintf (file, " %d (%x)",
  		     INSN_UID (ready[i]), INSN_PRIORITY (ready[i]));
--- 4258,4265 ----
  
        if (file)
  	{
! 	  fprintf (file, ";; ready list at T-%d (new_r %d n_r %d):", 
! 	  clock, new_ready, n_ready);
  	  for (i = 0; i < new_ready; i++)
  	    fprintf (file, " %d (%x)",
  		     INSN_UID (ready[i]), INSN_PRIORITY (ready[i]));
***************
*** 3934,3939 ****
--- 4478,4498 ----
  	      INSN_PRIORITY (insn) = DONE_PRIORITY;
  	    }
  	}
+ #ifdef AGI
+       if (possible_agi && reload_completed && flag_swap_for_agi)
+         {
+           rtx next_to_last = NEXT_INSN (last);	
+           if (try_eliminate_agi (last, file))
+             { /* last has been swapped downwards */
+               if (PREV_INSN (last) == tail)
+                 { /* last has moved down to become tail */
+                   tail = last;
+                 }
+               last = next_to_last;
+               insn = last;
+             }
+         }
+ #endif
      }
    if (q_size != 0)
      abort ();
***************
*** 3946,3951 ****
--- 4505,4538 ----
       TAIL is the last of those insns.  */
    head = insn;
  
+ /* intel1 */
+ #ifdef NO_STACK_REG_REORDER
+   if (NO_STACK_REG_REORDER)
+     { /* remove all the REG_DEP_TMP dependencies that were added */
+       for (tinsn = head; tinsn != NEXT_INSN (tail); tinsn = NEXT_INSN (tinsn))
+         {
+ 	  tlink = LOG_LINKS (tinsn); 
+ 	  tprev_link = tlink;
+ 	  while (tlink) 
+ 	    {
+ 	      if (REG_NOTE_KIND (tlink) == REG_DEP_TMP)
+ 	        {
+ 	          if (tlink == LOG_LINKS (tinsn))
+ 	            {
+ 	              LOG_LINKS (tinsn) = XEXP (tlink, 1);
+ 	            }
+ 	          else
+ 	            {
+ 	              XEXP (tprev_link, 1) = XEXP (tlink, 1);
+ 	            }
+ 	        }
+ 	      tprev_link = tlink;
+ 	      tlink = XEXP (tlink, 1);
+ 	    }
+         }
+     }
+ #endif /* NO_STACK_REG_REORDER */
+ 
    /* NOTE_LIST is the end of a chain of notes previously found
       among the insns.  Insert them at the beginning of the insns.  */
    if (note_list != 0)
***************
*** 4670,4680 ****
--- 5257,5355 ----
    int b;
    rtx insn;
  
+   cur_dump_file = dump_file;
    /* Taking care of this degenerate case makes the rest of
       this code simpler.  */
    if (n_basic_blocks == 0)
      return;
  
+   /* intel1 */
+ #ifdef STACK_REGS
+   if (STACK_NON_STACK_INTERLEAVE || STACK_REG_REORDER)
+     {
+       rtx tinsn = get_insns();
+       int found_stack_mode = 0;
+       while (tinsn && !found_stack_mode)
+         {
+           if (GET_CODE (tinsn) == INSN && GET_CODE (PATTERN (tinsn)) == SET
+               && IS_STACK_MODE (GET_MODE (SET_DEST (PATTERN (tinsn)))))
+             {
+               found_stack_mode = 1;
+             }
+           tinsn = next_nonnote_insn (tinsn);
+         }
+       if (!found_stack_mode) /* Nothing to do */
+         {
+           unused_insn_list = 0;
+           unused_expr_list = 0;
+           return;
+         }
+     }
+ #endif
+     /* intel1 - Remove all LOG_LINK information as the reload pass
+        may have invalidated some LOG_LINKs eg:
+        before reload:
+        (insn 21 20 24 (set (reg:SI 25)
+                (ashiftrt:SI (reg/v:SI 22)
+                    (const_int 3))) 142 {ashrsi3} (nil)
+            (nil))
+ 
+        (insn 24 21 28 (set (reg/v:SI 22)
+                (and:SI (reg/v:SI 22)
+                    (const_int 7))) 102 {andsi3} (nil)
+            (nil))
+ 
+        (insn 28 24 29 (set (reg:QI 27)
+                (and:QI (mem:QI (plus:SI (reg:SI 25)
+                            (symbol_ref:SI ("buf"))))
+                    (mem/s:QI (plus:SI (reg/v:SI 22)
+                            (symbol_ref:SI ("rmask")))))) 104 {andqi3}
+            (insn_list 21 (insn_list 24 (nil)))
+            (nil))
+ 
+        after reload:
+        (insn:HI 21 281 24 (set (reg:SI %edx)
+                (ashiftrt:SI (reg:SI %edx)
+                    (const_int 3))) 142 {ashrsi3} (nil)
+            (nil))
+ 
+ 
+        (insn 24 21 284 (set (reg/v:SI %ebp)
+                (and:SI (reg/v:SI %ebp)
+                    (const_int 7))) 102 {andsi3} (nil)
+            (nil))
+ 
+        (insn 284 24 28 (set (reg:QI %cl)
+                (mem:QI (plus:SI (reg:SI %edx)
+                        (symbol_ref:SI ("buf"))))) -1 (nil)
+            (nil))
+ 
+        (insn:HI 28 284 285 (set (reg:QI %cl)
+                (and:QI (reg:QI %cl)
+                    (mem/s:QI (plus:SI (reg/v:SI %ebp)
+                            (symbol_ref:SI ("rmask")))))) 104 {andqi3}
+            (insn_list 21 (insn_list 24 (nil)))
+             (nil))
+ 
+      Note that the LOG_LINKs of insn 28 is no longer valid - it does
+      not depend directly on insn 21 any longer. Leaving the LOG_LINKs
+      as they are may produce suboptimal, although valid, schedules.
+      */
+   if (reload_completed)
+     {
+       rtx tinsn = get_insns();
+       while (tinsn)
+         {
+           if (GET_CODE (tinsn) == INSN || GET_CODE (tinsn) == CALL_INSN
+               || GET_CODE (tinsn) == JUMP_INSN)
+             {
+               LOG_LINKS (tinsn) = NULL;
+             }
+           tinsn = next_nonnote_insn (tinsn);
+         }
+     }
+ 
+ 
    /* Create an insn here so that we can hang dependencies off of it later.  */
    sched_before_next_call
      = gen_rtx (INSN, VOIDmode, 0, NULL_RTX, NULL_RTX,
***************
*** 4815,4820 ****
--- 5490,5497 ----
  		  PUT_CODE (insn, NOTE);
  		  NOTE_LINE_NUMBER (insn) = NOTE_INSN_DELETED;
  		  NOTE_SOURCE_FILE (insn) = 0;
+ 		  /* intel1 */
+ 		  SCHED_GROUP_P(insn) = 0;
  		}
  
  	      continue;
***************
*** 4837,4842 ****
--- 5514,5521 ----
  		  PUT_CODE (insn, NOTE);
  		  NOTE_SOURCE_FILE (insn) = 0;
  		  NOTE_LINE_NUMBER (insn) = NOTE_INSN_DELETED;
+ 		  /* intel1 */
+ 		  SCHED_GROUP_P(insn) = 0;
  		  if (insn == basic_block_head[b])
  		    basic_block_head[b] = first;
  		  if (insn == basic_block_end[b])
***************
*** 4882,4887 ****
--- 5561,5568 ----
  		notes++;
  		NOTE_SOURCE_FILE (insn) = 0;
  		NOTE_LINE_NUMBER (insn) = NOTE_INSN_DELETED;
+ 		/* intel1 */
+ 		SCHED_GROUP_P(insn) = 0;
  	      }
  	    /* If the line number is unchanged, LINE is redundant.  */
  	    else if (line
